diff -ruN freeswan-1.9.orig/klips/net/ipsec/pfkey_v2.c freeswan-1.9/klips/net/ipsec/pfkey_v2.c
--- freeswan-1.9.orig/klips/net/ipsec/pfkey_v2.c	Mon Feb 26 19:51:01 2001
+++ freeswan-1.9/klips/net/ipsec/pfkey_v2.c	Wed May 16 10:57:20 2001
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey_v2.c,v 1.51.2.1 2001/02/27 00:51:01 henry Exp $
+ * RCSID $Id: pfkey_v2.c,v 1.58 2001/05/04 16:37:24 rgb Exp $
  */
 
 /*
@@ -275,7 +275,10 @@
 pfkey_data_ready(struct sock *sk, int len)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_data_ready: .sk=%p len=%d\n", sk, len);
+		    "klips_debug:pfkey_data_ready: "
+		    "sk=%p len=%d\n",
+		    sk,
+		    len);
 	if(!sk->dead) {
 		wake_up_interruptible(sk->sleep);
 		sock_wake_async(sk->socket, 1);
@@ -298,7 +301,9 @@
 pfkey_insert_socket(struct sock *sk)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_insert_socket: sk=%p\n", sk);
+		    "klips_debug:pfkey_insert_socket: "
+		    "sk=%p\n",
+		    sk);
 	cli();
 	sk->next=pfkey_sock_list;
 	pfkey_sock_list=sk;
@@ -321,14 +326,16 @@
 			sk->next=NULL;
 			sti();
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_remove_socket: succeeded.\n");
+				    "klips_debug:pfkey_remove_socket: "
+				    "succeeded.\n");
 			return;
 		}
 		s=&((*s)->next);
 	}
 	sti();
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_remove_socket: not found.\n");
+		    "klips_debug:pfkey_remove_socket: "
+		    "not found.\n");
 	return;
 }
 
@@ -341,7 +348,8 @@
 		    "klips_debug:pfkey_destroy_socket: .\n");
 	pfkey_remove_socket(sk);
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_destroy_socket: pfkey_remove_socket called.\n");
+		    "klips_debug:pfkey_destroy_socket: "
+		    "pfkey_remove_socket called.\n");
 	
 	KLIPS_PRINT(debug_pfkey,
 		    "klips_debug:pfkey_destroy_socket: "
@@ -355,8 +363,10 @@
 #ifdef CONFIG_IPSEC_DEBUG
 		if(debug_pfkey && sysctl_ipsec_debug_verbose) {
 			KLIPS_PRINT(debug_pfkey,
-				    "klips_debug:pfkey_destroy_socket: skb=%p dequeued.\n", skb);
-			printk(KERN_INFO "klips_debug: pfkey_skb contents:");
+				    "klips_debug:pfkey_destroy_socket: "
+				    "skb=%p dequeued.\n", skb);
+			printk(KERN_INFO "klips_debug:pfkey_destroy_socket: "
+			       "pfkey_skb contents:");
 			printk(" next:%p", skb->next);
 			printk(" prev:%p", skb->prev);
 			printk(" list:%p", skb->list);
@@ -386,8 +396,8 @@
 			}
 			printk(" len:%d", skb->len);
 			printk(" csum:%d", skb->csum);
-			printk(" used:%d", skb->used);
 #ifndef NETDEV_23
+			printk(" used:%d", skb->used);
 			printk(" is_clone:%d", skb->is_clone);
 #endif /* NETDEV_23 */
 			printk(" cloned:%d", skb->cloned);
@@ -413,12 +423,16 @@
 		}
 #endif /* CONFIG_IPSEC_DEBUG */
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_destroy_socket: skb=%p freed.\n", skb);
+			    "klips_debug:pfkey_destroy_socket: "
+			    "skb=%p freed.\n",
+			    skb);
 		kfree_skb(skb);
 
 #else /* NET_21 */
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_destroy_socket: skb=%p dequeued and freed.\n", skb);
+			    "klips_debug:pfkey_destroy_socket: "
+			    "skb=%p dequeued and freed.\n",
+			    skb);
 		kfree_skb(skb, FREE_WRITE);
 
 #endif /* NET_21 */
@@ -434,19 +448,21 @@
 int
 pfkey_upmsg(struct socket *sock, struct sadb_msg *pfkey_msg)
 {
-	int error;
+	int error = 0;
 	struct sk_buff * skb = NULL;
 	struct sock *sk;
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_upmsg: NULL socket passed in.\n");
+			    "klips_debug:pfkey_upmsg: "
+			    "NULL socket passed in.\n");
 		return -EINVAL;
 	}
 
 	if(pfkey_msg == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_upmsg: NULL pfkey_msg passed in.\n");
+			    "klips_debug:pfkey_upmsg: "
+			    "NULL pfkey_msg passed in.\n");
 		return -EINVAL;
 	}
 
@@ -458,27 +474,31 @@
 
 	if(sk == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_upmsg: NULL sock passed in.\n");
+			    "klips_debug:pfkey_upmsg: "
+			    "NULL sock passed in.\n");
 		return -EINVAL;
 	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_upmsg: allocating %d bytes...\n",
+		    "klips_debug:pfkey_upmsg: "
+		    "allocating %d bytes...\n",
 		    pfkey_msg->sadb_msg_len * IPSEC_PFKEYv2_ALIGN);
 	if(!(skb = alloc_skb(pfkey_msg->sadb_msg_len * IPSEC_PFKEYv2_ALIGN, GFP_ATOMIC) )) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_upmsg: no buffers left to send up a message.\n");
+			    "klips_debug:pfkey_upmsg: "
+			    "no buffers left to send up a message.\n");
 		return -ENOBUFS;
 	}
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_upmsg: ...allocated at %p.\n", skb);
+		    "klips_debug:pfkey_upmsg: "
+		    "...allocated at %p.\n",
+		    skb);
 	
 	skb->dev = NULL;
 	
 	if(skb_tailroom(skb) < pfkey_msg->sadb_msg_len * IPSEC_PFKEYv2_ALIGN) {
 		printk(KERN_WARNING "klips_error:pfkey_upmsg: "
-		       "tried to skb_put %ld, %d available.  "
-		       "This should never happen, please report.\n",
+		       "tried to skb_put %ld, %d available.  This should never happen, please report.\n",
 		       (unsigned long int)pfkey_msg->sadb_msg_len * IPSEC_PFKEYv2_ALIGN,
 		       skb_tailroom(skb));
 #ifdef NET_21
@@ -505,10 +525,11 @@
 		KLIPS_PRINT(debug_pfkey,
 			    "klips_debug:pfkey_upmsg: "
 			    "error=%d calling sock_queue_rcv_skb with skb=%p.\n",
-			    error, skb);
+			    error,
+			    skb);
 		return error;
 	}
-	return 0;
+	return error;
 }
 
 DEBUG_NO_STATIC int
@@ -518,12 +539,14 @@
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_create: socket NULL.\n");
+			    "klips_debug:pfkey_create: "
+			    "socket NULL.\n");
 		return -EINVAL;
 	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_create: sock=%p type:%d state:%d flags:%ld protocol:%d\n",
+		    "klips_debug:pfkey_create: "
+		    "sock=%p type:%d state:%d flags:%ld protocol:%d\n",
 		    sock,
 		    sock->type,
 		    (unsigned int)(sock->state),
@@ -531,19 +554,22 @@
 
 	if(sock->type != SOCK_RAW) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_create: only SOCK_RAW supported.\n");
+			    "klips_debug:pfkey_create: "
+			    "only SOCK_RAW supported.\n");
 		return -ESOCKTNOSUPPORT;
 	}
 
 	if(protocol != PF_KEY_V2) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_create: protocol not PF_KEY_V2.\n");
+			    "klips_debug:pfkey_create: "
+			    "protocol not PF_KEY_V2.\n");
 		return -EPROTONOSUPPORT;
 	}
 
 	if((current->uid != 0)) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_create: must be root to open pfkey sockets.\n");
+			    "klips_debug:pfkey_create: "
+			    "must be root to open pfkey sockets.\n");
 		return -EACCES;
 	}
 
@@ -558,7 +584,8 @@
 #endif /* NET_21 */
 	{
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_create: Out of memory trying to allocate.\n");
+			    "klips_debug:pfkey_create: "
+			    "Out of memory trying to allocate.\n");
 		MOD_DEC_USE_COUNT;
 		return -ENOMEM;
 	}
@@ -580,7 +607,8 @@
 	sk->protocol = protocol;
 	key_pid(sk) = current->pid;
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_create: sock->fasync_list=%p sk->sleep=%p.\n",
+		    "klips_debug:pfkey_create: "
+		    "sock->fasync_list=%p sk->sleep=%p.\n",
 		    sock->fasync_list,
 		    sk->sleep);
 #else /* NET_21 */
@@ -608,7 +636,8 @@
 	pfkey_list_insert_socket(sock, &pfkey_open_sockets);
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_create: Socket sock=%p sk=%p initialised.\n", sock, sk);
+		    "klips_debug:pfkey_create: "
+		    "Socket sock=%p sk=%p initialised.\n", sock, sk);
 	return 0;
 }
 
@@ -620,13 +649,15 @@
 
 	if(newsock==NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_dup: No new socket attached.\n");
+			    "klips_debug:pfkey_dup: "
+			    "No new socket attached.\n");
 		return -EINVAL;
 	}
 		
 	if(oldsock==NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_dup: No old socket attached.\n");
+			    "klips_debug:pfkey_dup: "
+			    "No old socket attached.\n");
 		return -EINVAL;
 	}
 		
@@ -639,7 +670,8 @@
 	/* May not have data attached */
 	if(sk==NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_dup: No sock attached to old socket.\n");
+			    "klips_debug:pfkey_dup: "
+			    "No sock attached to old socket.\n");
 		return -EINVAL;
 	}
 		
@@ -662,7 +694,8 @@
 
 	if(sock==NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_release: No socket attached.\n");
+			    "klips_debug:pfkey_release: "
+			    "No socket attached.\n");
 		return 0; /* -EINVAL; */
 	}
 		
@@ -675,12 +708,14 @@
 	/* May not have data attached */
 	if(sk==NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_release: No sk attached to sock=%p.\n", sock);
+			    "klips_debug:pfkey_release: "
+			    "No sk attached to sock=%p.\n", sock);
 		return 0; /* -EINVAL; */
 	}
 		
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_release: .sock=%p sk=%p\n", sock, sk);
+		    "klips_debug:pfkey_release: "
+		    "sock=%p sk=%p\n", sock, sk);
 
 #ifdef NET_21
 	if(!sk->dead)
@@ -704,7 +739,8 @@
 
 	MOD_DEC_USE_COUNT;
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_release: succeeded.\n");
+		    "klips_debug:pfkey_release: "
+		    "succeeded.\n");
 
 	return 0;
 }
@@ -714,7 +750,8 @@
 pfkey_bind(struct socket *sock, struct sockaddr *uaddr, int addr_len)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_bind: operation not supported.\n");
+		    "klips_debug:pfkey_bind: "
+		    "operation not supported.\n");
 	return -EINVAL;
 }
 
@@ -722,7 +759,8 @@
 pfkey_connect(struct socket *sock, struct sockaddr *uaddr, int addr_len, int flags)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_connect: operation not supported.\n");
+		    "klips_debug:pfkey_connect: "
+		    "operation not supported.\n");
 	return -EINVAL;
 }
 
@@ -730,7 +768,8 @@
 pfkey_socketpair(struct socket *a, struct socket *b)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_socketpair: operation not supported.\n");
+		    "klips_debug:pfkey_socketpair: "
+		    "operation not supported.\n");
 	return -EINVAL;
 }
 
@@ -738,7 +777,8 @@
 pfkey_accept(struct socket *sock, struct socket *newsock, int flags)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_aaccept: operation not supported.\n");
+		    "klips_debug:pfkey_aaccept: "
+		    "operation not supported.\n");
 	return -EINVAL;
 }
 
@@ -760,13 +800,15 @@
 {
 	
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_select: .sock=%p sk=%p sel_type=%d\n",
+		    "klips_debug:pfkey_select: "
+		    ".sock=%p sk=%p sel_type=%d\n",
 		    sock,
 		    sock->data,
 		    sel_type);
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_select: Null socket passed in.\n");
+			    "klips_debug:pfkey_select: "
+			    "Null socket passed in.\n");
 		return -EINVAL;
 	}
 	return datagram_select(sock->data, sel_type, wait);
@@ -776,7 +818,8 @@
 pfkey_ioctl(struct socket *sock, unsigned int cmd, unsigned long arg)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_ioctl: not supported.\n");
+		    "klips_debug:pfkey_ioctl: "
+		    "not supported.\n");
 	return -EINVAL;
 }
 
@@ -784,7 +827,8 @@
 pfkey_listen(struct socket *sock, int backlog)
 {
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_listen: not supported.\n");
+		    "klips_debug:pfkey_listen: "
+		    "not supported.\n");
 	return -EINVAL;
 }
 #endif /* !NET_21 */
@@ -796,7 +840,8 @@
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_shutdown: NULL socket passed in.\n");
+			    "klips_debug:pfkey_shutdown: "
+			    "NULL socket passed in.\n");
 		return -EINVAL;
 	}
 
@@ -808,12 +853,14 @@
 	
 	if(sk == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_shutdown: No sock attached to socket.\n");
+			    "klips_debug:pfkey_shutdown: "
+			    "No sock attached to socket.\n");
 		return -EINVAL;
 	}
 
 	KLIPS_PRINT(debug_pfkey,
-		    "klips_debug:pfkey_shutdown: mode=%x.\n", mode);
+		    "klips_debug:pfkey_shutdown: "
+		    "mode=%x.\n", mode);
 	mode++;
 	
 	if(mode&SEND_SHUTDOWN) {
@@ -837,7 +884,8 @@
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_setsockopt: Null socket passed in.\n");
+			    "klips_debug:pfkey_setsockopt: "
+			    "Null socket passed in.\n");
 		return -EINVAL;
 	}
 	
@@ -845,7 +893,8 @@
 	
 	if(sk == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_setsockopt: Null sock passed in.\n");
+			    "klips_debug:pfkey_setsockopt: "
+			    "Null sock passed in.\n");
 		return -EINVAL;
 	}
 #endif /* !NET_21 */
@@ -870,7 +919,8 @@
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_setsockopt: Null socket passed in.\n");
+			    "klips_debug:pfkey_setsockopt: "
+			    "Null socket passed in.\n");
 		return -EINVAL;
 	}
 	
@@ -878,7 +928,8 @@
 	
 	if(sk == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_setsockopt: Null sock passed in.\n");
+			    "klips_debug:pfkey_setsockopt: "
+			    "Null sock passed in.\n");
 		return -EINVAL;
 	}
 #endif /* !NET_21 */
@@ -1073,17 +1124,19 @@
 		for(pfkey_socketsp = pfkey_open_sockets;
 		    pfkey_socketsp;
 		    pfkey_socketsp = pfkey_socketsp->next) {
+			int error_upmsg = 0;
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_sendmsg: "
 				    "sending up error=%d message=%p to socket=%p.\n",
 				    error,
 				    pfkey_reply,
 				    pfkey_socketsp->socketp);
-			if((error = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
+			if((error_upmsg = pfkey_upmsg(pfkey_socketsp->socketp, pfkey_reply))) {
 				KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_sendmsg: "
 					    "sending up error message to socket=%p failed with error=%d.\n",
-					    pfkey_socketsp->socketp, error);
+					    pfkey_socketsp->socketp,
+					    error_upmsg);
 				pfkey_msg_free(&pfkey_reply);
-				goto errlab;
+				SENDERR(-error);
 			}
 			KLIPS_PRINT(debug_pfkey, "klips_debug:pfkey_sendmsg: "
 				    "sending up error message to socket=%p succeeded.\n",
@@ -1127,7 +1180,8 @@
 
 	if(sock == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_recvmsg: Null socket passed in.\n");
+			    "klips_debug:pfkey_recvmsg: "
+			    "Null socket passed in.\n");
 		return -EINVAL;
 	}
 
@@ -1139,13 +1193,15 @@
 
 	if(sk == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_recvmsg: Null sock passed in for sock=%p.\n", sock);
+			    "klips_debug:pfkey_recvmsg: "
+			    "Null sock passed in for sock=%p.\n", sock);
 		return -EINVAL;
 	}
 
 	if(msg == NULL) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_recvmsg: Null msghdr passed in for sock=%p, sk=%p.\n",
+			    "klips_debug:pfkey_recvmsg: "
+			    "Null msghdr passed in for sock=%p, sk=%p.\n",
 			    sock, sk);
 		return -EINVAL;
 	}
@@ -1155,7 +1211,8 @@
 		    sock, sk, msg, size);
 	if(flags & ~MSG_PEEK) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_sendmsg: flags (%d) other than MSG_PEEK not supported.\n",
+			    "klips_debug:pfkey_sendmsg: "
+			    "flags (%d) other than MSG_PEEK not supported.\n",
 			    flags);
 		return -EOPNOTSUPP;
 	}
@@ -1170,7 +1227,8 @@
 		
 	if(sk->err) {
 		KLIPS_PRINT(debug_pfkey,
-			    "klips_debug:pfkey_sendmsg: sk->err=%d.\n", sk->err);
+			    "klips_debug:pfkey_sendmsg: "
+			    "sk->err=%d.\n", sk->err);
 		return sock_error(sk);
 	}
 
@@ -1286,10 +1344,12 @@
 #ifdef CONFIG_IPSEC_DEBUG
 	if(!sysctl_ipsec_debug_verbose) {
 #endif CONFIG_IPSEC_DEBUG
-	len+= sprintf(buffer,"    sock   pid   socket     next     prev e n p sndbf    Flags     Type St\n");
+	len+= sprintf(buffer,
+		      "    sock   pid   socket     next     prev e n p sndbf    Flags     Type St\n");
 #ifdef CONFIG_IPSEC_DEBUG
 	} else {
-	len+= sprintf(buffer,"    sock   pid d    sleep   socket     next     prev e r z n p sndbf    stamp    Flags     Type St\n");
+	len+= sprintf(buffer,
+		      "    sock   pid d    sleep   socket     next     prev e r z n p sndbf    stamp    Flags     Type St\n");
 	}
 #endif CONFIG_IPSEC_DEBUG
 	
@@ -1297,7 +1357,8 @@
 #ifdef CONFIG_IPSEC_DEBUG
 		if(!sysctl_ipsec_debug_verbose) {
 #endif CONFIG_IPSEC_DEBUG
-		len+=sprintf(buffer+len,"%8p %5d %8p %8p %8p %d %d %d %5d %08lX %8X %2X\n",
+		len+=sprintf(buffer+len,
+			     "%8p %5d %8p %8p %8p %d %d %d %5d %08lX %8X %2X\n",
 			     sk,
 			     key_pid(sk),
 			     sk->socket,
@@ -1312,7 +1373,8 @@
 			     sk->socket->state);
 #ifdef CONFIG_IPSEC_DEBUG
 		} else {
-		len+=sprintf(buffer+len,"%8p %5d %d %8p %8p %8p %8p %d %d %d %d %d %5d %d.%06d %08lX %8X %2X\n",
+		len+=sprintf(buffer+len,
+			     "%8p %5d %d %8p %8p %8p %8p %d %d %d %d %d %5d %d.%06d %08lX %8X %2X\n",
 			     sk,
 			     key_pid(sk),
 			     sk->dead,
@@ -1367,12 +1429,14 @@
 	int satype;
 	struct supported_list *pfkey_supported_p;
 	
-	len+= sprintf(buffer,"satype exttype alg_id ivlen minbits maxbits\n");
+	len+= sprintf(buffer,
+		      "satype exttype alg_id ivlen minbits maxbits\n");
 	
 	for(satype = SADB_SATYPE_UNSPEC; satype <= SADB_SATYPE_MAX; satype++) {
 		pfkey_supported_p = pfkey_supported_list[satype];
 		while(pfkey_supported_p) {
-			len+=sprintf(buffer+len,"    %2d      %2d     %2d   %3d     %3d     %3d\n",
+			len+=sprintf(buffer+len,
+				     "    %2d      %2d     %2d   %3d     %3d     %3d\n",
 				     satype,
 				     pfkey_supported_p->supportedp->supported_alg_exttype,
 				     pfkey_supported_p->supportedp->supported_alg_id,
@@ -1413,19 +1477,22 @@
 	int satype;
 	struct socket_list *pfkey_sockets;
 	
-	len+= sprintf(buffer,"satype   socket   pid       sk\n");
+	len+= sprintf(buffer,
+		      "satype   socket   pid       sk\n");
 	
 	for(satype = SADB_SATYPE_UNSPEC; satype <= SADB_SATYPE_MAX; satype++) {
 		pfkey_sockets = pfkey_registered_sockets[satype];
 		while(pfkey_sockets) {
 #ifdef NET_21
-			len+=sprintf(buffer+len,"    %2d %8p %5d %8p\n",
+			len+=sprintf(buffer+len,
+				     "    %2d %8p %5d %8p\n",
 				     satype,
 				     pfkey_sockets->socketp,
 				     key_pid(pfkey_sockets->socketp->sk),
 				     pfkey_sockets->socketp->sk);
 #else /* NET_21 */
-			len+=sprintf(buffer+len,"    %2d %8p   N/A %8p\n",
+			len+=sprintf(buffer+len,
+				     "    %2d %8p   N/A %8p\n",
 				     satype,
 				     pfkey_sockets->socketp,
 #if 0
@@ -1565,36 +1632,40 @@
 	};
 #endif /* CONFIG_IPSEC_IPCOMP */
 
-        printk(KERN_INFO "IPsec: initialising PF_KEY domain sockets.\n");
+#if 0
+        printk(KERN_INFO
+	       "klips_info:pfkey_init: "
+	       "FreeS/WAN: initialising PF_KEYv2 domain sockets.\n");
+#endif
 
 	for(i = SADB_SATYPE_UNSPEC; i <= SADB_SATYPE_MAX; i++) {
 		pfkey_registered_sockets[i] = NULL;
 		pfkey_supported_list[i] = NULL;
 	}
 
-	supported_add_all(SADB_SATYPE_AH, supported_init_ah, sizeof(supported_init_ah));
-	supported_add_all(SADB_SATYPE_ESP, supported_init_esp, sizeof(supported_init_esp));
+	error |= supported_add_all(SADB_SATYPE_AH, supported_init_ah, sizeof(supported_init_ah));
+	error |= supported_add_all(SADB_SATYPE_ESP, supported_init_esp, sizeof(supported_init_esp));
 #ifdef CONFIG_IPSEC_IPCOMP
-	supported_add_all(SADB_X_SATYPE_COMP, supported_init_ipcomp, sizeof(supported_init_ipcomp));
+	error |= supported_add_all(SADB_X_SATYPE_COMP, supported_init_ipcomp, sizeof(supported_init_ipcomp));
 #endif /* CONFIG_IPSEC_IPCOMP */
-	supported_add_all(SADB_X_SATYPE_IPIP, supported_init_ipip, sizeof(supported_init_ipip));
+	error |= supported_add_all(SADB_X_SATYPE_IPIP, supported_init_ipip, sizeof(supported_init_ipip));
 
 #ifdef NET_21
-        sock_register(&pfkey_family_ops);
+        error |= sock_register(&pfkey_family_ops);
 #else /* NET_21 */
-        sock_register(pfkey_proto_ops.family, &pfkey_proto_ops);
+        error |= sock_register(pfkey_proto_ops.family, &pfkey_proto_ops);
 #endif /* NET_21 */
 
 #ifdef CONFIG_PROC_FS
 #  ifndef PROC_FS_2325
 #    ifdef PROC_FS_21
-	proc_register(proc_net, &proc_net_pfkey);
-	proc_register(proc_net, &proc_net_pfkey_supported);
-	proc_register(proc_net, &proc_net_pfkey_registered);
+	error |= proc_register(proc_net, &proc_net_pfkey);
+	error |= proc_register(proc_net, &proc_net_pfkey_supported);
+	error |= proc_register(proc_net, &proc_net_pfkey_registered);
 #    else /* PROC_FS_21 */
-	proc_register_dynamic(&proc_net, &proc_net_pfkey);
-	proc_register_dynamic(&proc_net, &proc_net_pfkey_supported);
-	proc_register_dynamic(&proc_net, &proc_net_pfkey_registered);
+	error |= proc_register_dynamic(&proc_net, &proc_net_pfkey);
+	error |= proc_register_dynamic(&proc_net, &proc_net_pfkey_supported);
+	error |= proc_register_dynamic(&proc_net, &proc_net_pfkey_registered);
 #    endif /* PROC_FS_21 */
 #  else /* !PROC_FS_2325 */
 	proc_net_create ("pf_key", 0, pfkey_get_info);
@@ -1611,28 +1682,32 @@
 {
 	int error = 0;
 	
-        printk(KERN_INFO "FreeS/WAN: shutting down PF_KEY domain sockets.\n");
+        printk(KERN_INFO "klips_info:pfkey_cleanup: "
+	       "shutting down PF_KEY domain sockets.\n");
 #ifdef NET_21
-        sock_unregister(PF_KEY);
+        error |= sock_unregister(PF_KEY);
 #else /* NET_21 */
-        sock_unregister(pfkey_proto_ops.family);
+        error |= sock_unregister(pfkey_proto_ops.family);
 #endif /* NET_21 */
 
-	supported_remove_all(SADB_SATYPE_AH);
-	supported_remove_all(SADB_SATYPE_ESP);
+	error |= supported_remove_all(SADB_SATYPE_AH);
+	error |= supported_remove_all(SADB_SATYPE_ESP);
 #ifdef CONFIG_IPSEC_IPCOMP
-	supported_remove_all(SADB_X_SATYPE_COMP);
+	error |= supported_remove_all(SADB_X_SATYPE_COMP);
 #endif /* CONFIG_IPSEC_IPCOMP */
-	supported_remove_all(SADB_X_SATYPE_IPIP);
+	error |= supported_remove_all(SADB_X_SATYPE_IPIP);
 
 #ifdef CONFIG_PROC_FS
 #  ifndef PROC_FS_2325
 	if (proc_net_unregister(proc_net_pfkey.low_ino) != 0)
-		printk("klips_debug:pfkey_cleanup: cannot unregister /proc/net/pf_key\n");
+		printk("klips_debug:pfkey_cleanup: "
+		       "cannot unregister /proc/net/pf_key\n");
 	if (proc_net_unregister(proc_net_pfkey_supported.low_ino) != 0)
-		printk("klips_debug:pfkey_cleanup: cannot unregister /proc/net/pf_key_supported\n");
+		printk("klips_debug:pfkey_cleanup: "
+		       "cannot unregister /proc/net/pf_key_supported\n");
 	if (proc_net_unregister(proc_net_pfkey_registered.low_ino) != 0)
-		printk("klips_debug:pfkey_cleanup: cannot unregister /proc/net/pf_key_registered\n");
+		printk("klips_debug:pfkey_cleanup: "
+		       "cannot unregister /proc/net/pf_key_registered\n");
 #  else /* !PROC_FS_2325 */
 	proc_net_remove ("pf_key");
 	proc_net_remove ("pf_key_supported");
@@ -1669,8 +1744,30 @@
 
 /*
  * $Log: pfkey_v2.c,v $
- * Revision 1.51.2.1  2001/02/27 00:51:01  henry
- * message improvements
+ * Revision 1.58  2001/05/04 16:37:24  rgb
+ * Remove erroneous checking of return codes for proc_net_* in 2.4.
+ *
+ * Revision 1.57  2001/05/03 19:43:36  rgb
+ * Initialise error return variable.
+ * Check error return codes in startup and shutdown.
+ * Standardise on SENDERR() macro.
+ *
+ * Revision 1.56  2001/04/21 23:05:07  rgb
+ * Define out skb->used for 2.4 kernels.
+ *
+ * Revision 1.55  2001/02/28 05:03:28  rgb
+ * Clean up and rationalise startup messages.
+ *
+ * Revision 1.54  2001/02/27 22:24:55  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.53  2001/02/27 06:48:18  rgb
+ * Fixed pfkey socket unregister log message to reflect type and function.
+ *
+ * Revision 1.52  2001/02/26 22:34:38  rgb
+ * Fix error return code that was getting overwritten by the error return
+ * code of an upmsg.
  *
  * Revision 1.51  2001/01/30 23:42:47  rgb
  * Allow pfkey msgs from pid other than user context required for ACQUIRE
